# Thanks to SuperDave who made that pickle thread which syntax is pretty much the same as cPickle
# Again thanks to SuperDave who made the escapelib, it was a great help
# Again, thanks to SuperDave who helped with some nub errors I made

import es, cPickle, os.path, playerlib, popuplib, gamethread, bbankconfig
from bbankconfig import *


player_data = {}

info = es.AddonInfo() 
info['name']        = "BBank" 
info['version']     = "2.8" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://www.notimplementedyet.com" 
info['description'] = "A new bank with lots of added features" 

first_round = 0
es.ServerVar('bbank_version', info['version'], 'BBank made by Bonbon AKA Bonbon367').makepublic()
round_ended = 0

dict_saycommands = {
	'!bank': {'block': 'showmenu', 'description': 'Show the main bank menu'},
	'!deposit': {'block': 'deposit', 'description': 'Quick deposit command'},
	'!withdraw': {'block': 'withdraw', 'description': 'Quick withdraw command'},
	'!badmin': {'block': 'admin', 'description': 'Show the admin menu'},
	'badmin': {'block': 'admin', 'description': 'Show the admin menu'},
	'bank': {'block': 'showmenu', 'description': 'Show the main bank menu'},
	'deposit': {'block': 'deposit', 'description': 'Quick deposit command'},
	'withdraw': {'block': 'withdraw', 'description': 'Quick withdraw command'},
	'transfer': {'block': 'transfer', 'description': 'Quick transfer command'},
	'!transfer': {'block': 'transfer', 'description': 'Quick transfer command'},
	'give': {'block': 'transfer', 'description': 'Quick transfer command'},
	'!give': {'block': 'transfer', 'description': 'Quick transfer command'}
}

dict_clientcommands = {
	'cash': {'block': 'givecash', 'description': 'None'},
	'abalance': {'block': 'abalance', 'description': 'Always have x amount of cash in the bank'}
}

def load():
	for client_command in dict_clientcommands:
		if not es.exists('clientcommand', client_command):
			es.regclientcmd(client_command, 'bbank/%s'%dict_clientcommands[client_command]['block'], dict_clientcommands[client_command]['description'])
	for saycommand in dict_saycommands:
		if not es.exists('saycommand', saycommand):
			es.regsaycmd(saycommand, 'bbank/%s'%dict_saycommands[saycommand]['block'], dict_saycommands[saycommand]['description'])
		if not es.exists('clientcommand', saycommand):
			es.regclientcmd(saycommand, 'bbank/%s'%dict_saycommands[saycommand]['block'], dict_saycommands[saycommand]['description'])
	mainmenu = popuplib.easymenu('BBank', '_popup_choice', main_menu_select)
	depositmenu = popuplib.easymenu('Deposit', '_popup_choice', deposit_select)
	withdrawmenu = popuplib.easymenu('Withdraw', '_popup_choice', withdraw_select)
	transfermenu = popuplib.easymenu('Transfer', '_popup_choice', transfer_select)
	adminmenu = popuplib.easymenu('Admin Menu', '_popup_choice', admin_select)
	playerinfo = popuplib.easymenu('Player Info', '_popup_choice', pinfo_select)
	settings = popuplib.easymenu('Settings', '_popup_choice', settings_select)
	accounttype = popuplib.easymenu('Chose New Account', '_popup_choice', account_type_select)
	adminmenu.addoption('Give/Take Cash', 'Give/Take Cash')
	adminmenu.addoption('Reset', 'Reset BBank')
	adminmenu.addoption('Change Player Accounts', 'Change Player Accounts')
	confirmmenu = popuplib.easymenu('Are You Sure?', '_popup_choice', confirm_reset)
	confirmmenu2 = popuplib.easymenu('Reset Account?', '_popup_choice', confirm_reset_2)
	for confirm_option in ('Yes', 'No'):
		confirmmenu.addoption(confirm_option, confirm_option)
		confirmmenu2.addoption(confirm_option, confirm_option)
	depositmenu.addoption('all', 'all')
	withdrawmenu.addoption('all', 'all')
	for b in ('1000', '2000', '4000', '8000', '10000', '14000'):
		depositmenu.addoption(b, b)
		withdrawmenu.addoption(b, b)
	mainmenu.addoption('Show Balance', 'Show Balance')
	mainmenu.addoption('Transfer', 'Transfer')
	mainmenu.addoption('Deposit', 'Deposit')
	mainmenu.addoption('Withdraw', 'Withdraw')
	mainmenu.addoption('Top', 'Top')
	mainmenu.addoption('Player Info', 'Player Info')
	mainmenu.addoption('Settings', 'Settings')
	depositmenu.submenu(0, 'BBank')
	withdrawmenu.submenu(0, 'BBank')
	settings.submenu(0, 'BBank')
	confirmmenu2.submenu(0, 'Settings')
	confirmmenu.submenu(0, 'Admin Menu')
	for settings_option in ('Auto Balance', 'Reset Account'):
		settings.addoption(settings_option, settings_option)
	player_db = es.getAddonPath('bbank') + '/player_info.db'
	if os.path.isfile(player_db):
		global player_data
		player_cash = open(player_db)
		player_data = cPickle.load(player_cash)
		player_cash.close()
	es.msg('#multi', '%sLoaded - Made by Bonbon: AKA Bonbon367'%tell_format)

def unload():
	for command in dict_clientcommands:
		if es.exists('clientcommand', command):
			es.unregclientcmd(command)
	for saycommand in dict_saycommands:
		if es.exists('saycommand', saycommand):
			es.unregclientcmd(saycommand)
	save_data()
	es.msg('#multi', '%sUnloaded - Made by Bonbon: AKA Bonbon367'%tell_format)

def player_activate(ev):
	steamid = ev['es_steamid']
	if player_data.has_key(steamid):
		global player_data
		bank(ev['userid'], ev['es_steamid']).intrest('player_activate', 'coming back to the server')
		player_data[steamid]['name'] = ev['es_username']
	else:
		bank(ev['userid'], steamid).create()

def es_map_start(ev):
	global first_round
	first_round = 0
	for userid in playerlib.getUseridList('#all'):
		bank(userid, playerlib.getPlayer(userid).get('steamid')).intrest('map_start', 'The map starting')

def round_end(ev):
	save_data()
	for userid in playerlib.getUseridList('#all'): 
		bank(userid, playerlib.getPlayer(userid).get('steamid')).intrest('round_end', 'the round ending')
	if ev['winner'] == '2': filter = '#t'
	elif ev['winner'] == '3': filter = '#ct'
	else: filter = '#all'
	for userid in playerlib.getUseridList(filter):
		bank(userid, playerlib.getPlayer(userid).get('steamid')).intrest('round_won', 'winning the round')
	for userid in playerlib.getUseridList('#alive'):
		bank(userid, playerlib.getPlayer(userid).get('steamid')).intrest('round_survived', 'surviving the round')
	if first_round == 0:
		global first_round
		first_round = 1
	global round_ended
	round_ended = 1

def bomb_defused(ev):
	bank(ev['userid'], ev['es_steamid']).intrest('bomb_defuse', 'defusing the bomb')

def bomb_planted(ev):
	bank(ev['userid'], ev['es_steamid']).intrest('bomb_plant', 'planting the bomb')

def bomb_exploded(ev):
	bank(ev['userid'], ev['es_steamid']).intrest('bomb_explode', 'the bomb exploding')

def hostage_rescued(ev):
	bank(ev['userid'], ev['es_steamid']).intrest('hostage_rescue', 'rescuing a hostage')

def round_start(ev):
	global player_data
	global round_ended
	round_ended = 0
	for a in playerlib.getUseridList('#all'):
		player_data[playerlib.getPlayer(a).get('steamid')]['withdraws'] = 0

class bank:
	def __init__(self, userid, steamid):
		self.userid = userid
		self.steamid = steamid

	def deposit(self, amount):
		if not round_ended:
			global player_data
			if self.steamid != 'BOT':
				if playerlib.getPlayer(self.userid).get('cash') >= amount:
					if player_data[self.steamid]['cash'] + amount <= account_types[player_data[self.steamid]['type']]['max_balance'] or account_types[player_data[self.steamid]['type']]['max_balance'] == 0:
						player_data[self.steamid]['cash'] += int(amount)
						playerlib.getPlayer(self.userid).set('cash', int(playerlib.getPlayer(self.userid).get('cash')) - int(amount))
						es.tell(self.userid, '#multi', '%sYou have deposited #lightgreen%s #green into the bank you now have #lightgreen%s'%(tell_format, int(amount), int(player_data[self.steamid]['cash'])))
					else:
						es.tell(self.userid, '#multi', '%sSorry, you have exeeded the maximum balance on your account'%tell_format)
				else:
					es.tell(self.userid, '#multi', '%sYou do not have #lightgreen%s #greento deposit!'%(tell_format, int(amount)))
		else:
				es.tell(self.userid, '#multi', '%sWHAT NAO!?'%tell_format)

	def transfer(self, target_userid, target_steamid, amount):
		global player_data
		if self.steamid != 'BOT' and target_steamid != 'BOT':
			if amount > 0 and amount <= player_data[self.steamid]['cash']:
				player_data[self.steamid]['cash'] -= amount
				player_data[target_steamid]['cash'] += amount
				es.tell(target_userid, '#multi', '%sYou have recieved #lightgreen%s #greendollars into your account from %s'%(tell_format, amount, playerlib.getPlayer(self.userid).attributes['name']))
				es.tell(self.userid, '#multi', '%sYou have sent #lightgreen%s #greendollars to %s'%(tell_format, amount, playerlib.getPlayer(target_userid).attributes['name']))

	def withdraw(self, amount):
		if not round_ended:
			global player_data
			if self.steamid != 'BOT':
				if player_data[self.steamid]['cash'] >= amount:
					if first_round == 1 or withdraw_on_first_round == 1:
						if player_data[self.steamid]['withdraws'] < account_types[player_data[self.steamid]['type']]['max_withdraws'] or account_types[player_data[self.steamid]['type']]['max_withdraws'] == 0:
							if playerlib.getPlayer(self.userid).get('cash') + int(amount) <= 16000:
								player_data[self.steamid]['cash'] -= int(amount)
								playerlib.getPlayer(self.userid).set('cash', int(playerlib.getPlayer(self.userid).get('cash')) + int(amount))
								player_data[self.steamid]['withdraws'] += 1
								es.tell(self.userid, '#multi', '%sYou have withdrawn #lightgreen%s#green dollars from the bank and have #lightgreen%s #green remaining'%(tell_format, amount, int(player_data[self.steamid]['cash'])))
							else:
								es.tell(self.userid, '#multi', '%sYou cannot have more than $16000!'%tell_format)
						else:
							es.tell(self.userid, '#multi', '%sYou do not have any withdraws left!'%tell_format)
					else:
						es.tell(self.userid, '#multi', '%sYou cannot withdraw on the first round!'%tell_format)
				else: 
					es.tell(self.userid, '#multi', '%sYou do not have #lightgreen%s #greento withdraw!'%(tell_format, int(amount)))
		else:
			es.tell(self.userid, '#multi', '%sWHAT NAO!?'%tell_format)

	def intrest(self, event, message):
		global player_data
		if self.steamid != 'BOT':
			if player_data[self.steamid].has_key('intrest'):
				player_data[self.steamid]['cash'] *= 1 + intrest_rates[event]
				if player_data[self.steamid]['cash'] * (intrest_rates[event] * account_types[player_data[self.steamid]['type']]['intrest_multiplier']) > 5:
					if bbank_tell_every_intrest:
						es.tell(self.userid, '#multi', '%sYou have gained #lightgreen%s #greenintrest for %s'%(tell_format, int(player_data[self.steamid]['cash'] * (intrest_rates[event] * account_types[player_data[self.steamid]['type']]['intrest_multiplier'])), message))
					else:
						player_data[self.steamid]['intrest'] = intrest_rates[event] * player_data[self.steamid]['cash']
			else:
				player_data[self.steamid]['intrest'] = 0

	def create(self):
		global player_data
		player_data[self.steamid] = {}
		player_data[self.steamid]['cash'] = start_cash
		player_data[self.steamid]['name'] = playerlib.getPlayer(self.userid).attributes['name']
		player_data[self.steamid]['withdraws'] = 0
		player_data[self.steamid]['abalance'] = 0
		player_data[self.steamid]['intrest'] = 0
		player_data[self.steamid]['type'] = 'Default'
		es.tell(self.userid, '#multi', '%sAccount Created'%tell_format)

	def abalance(self):
		if player_data[self.steamid]['abalance']:
			if playerlib.getPlayer(self.userid).get('cash') > player_data[self.steamid]['abalance']:
				self.deposit(playerlib.getPlayer(self.userid).get('cash') - player_data[self.steamid]['abalance'])
			elif playerlib.getPlayer(self.userid).get('cash') < player_data[self.steamid]['abalance']:
				self.withdraw(int(player_data[self.steamid]['abalance']) - (playerlib.getPlayer(self.userid).get('cash')))
	
	def check_keys(self):
		global player_data
		keys = {'cash': start_cash, 'name': 'unnamed', 'withdraws': 0, 'abalance': 0, 'intrest': 0, 'type': 'Default'}
		for a in keys:
			if not player_data[self.steamid].has_key(a):
				player_data[self.steamid][a] = keys[a]

def showmenu():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	popuplib.send('BBank', userid)
	if not player_data.has_key(steamid):
		bank(userid, steamid).create()

def deposit():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	amount = es.getargv(1)
	if es.getargc() >= 2:
		if amount == 'all':
			amount = playerlib.getPlayer(userid).get('cash')
		else:
			amount = int(amount)
		bank(userid, steamid).deposit(amount)
	else:
		popuplib.send('Deposit', userid)

def withdraw():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	amount = es.getargv(1)
	if es.getargc() >= 2:
		if amount == 'all':
			if player_data[steamid]['cash'] >= 16000 - int(playerlib.getPlayer(userid).get('cash')):
				amount = 16000 - int(playerlib.getPlayer(userid).get('cash'))
			else:
				amount = player_data[steamid]['cash']
			bank(userid, steamid).withdraw(amount)
		else:
			amount = int(amount)
			bank(userid, steamid).withdraw(amount)
	else:
		popuplib.send('Withdraw', userid)

def main_menu_select(userid, choice, popupid):
	if choice == 'Transfer':
		transfermenu = popuplib.easymenu('Transfer', '_popup_choice', transfer_select)
		for userid2 in playerlib.getUseridList('#all'):
			transfermenu.addoption(userid2, playerlib.getPlayer(userid2).attributes['name'])
	elif choice == 'Show Balance':
		es.tell(userid, '#multi', '%sYou have #lightgreen%s #greenin the bank'%(tell_format, int(player_data[playerlib.getPlayer(userid).get('steamid')]['cash'])))
	elif choice == 'Top':
		t___t = players_in_top
		top = popuplib.easymenu('Top', '_popup_choice', top_select)
		xy = []
		for b in player_data.keys():
			xy.append(player_data[b]['cash'])
		xy.sort()
		for a in xy:
			t___t -= 1
			if t___t >= 0:
				top.addoption(a, '%s: %s'%(player_data[a]['name'], int(player_data[a]['cash'])))
	elif choice == 'Player Info':
		playerinfo = popuplib.easymenu('Player Info', '_popup_choice', pinfo_select)
		for userid2 in playerlib.getUseridList('#all'):
			playerinfo.addoption(userid2, playerlib.getPlayer(userid2).attributes['name'])
	popuplib.send(choice, userid)

def deposit_select(userid, choice, popupid):
	if choice == 'all':
		amount = int(playerlib.getPlayer(userid).get('cash'))
	else:
		amount = int(choice)
	bank(userid, playerlib.getPlayer(userid).get('steamid')).deposit(amount)

def withdraw_select(userid, choice, popupid):
	if choice == 'all':
		amount = 16000 - int(playerlib.getPlayer(userid).get('cash'))
	else:
		amount = int(choice)
	bank(userid, playerlib.getPlayer(userid).get('steamid')).withdraw(amount)


def transfer_select(userid, choice, popupid):
	transfermenu2 = popuplib.easymenu('Transfer Amount', '_popup_choice', transfer_select2)
	for a in ('all', '1000', '2000', '4000', '8000', '16000', '20000', '40000'):
		transfermenu2.addoption((choice, a), a)
	popuplib.send('Transfer Amount', userid)

def transfer_select2(userid, choice, popupid):
	steamid = playerlib.getPlayer(userid).get('steamid')
	target_steamid = playerlib.getPlayer(choice[0]).get('steamid')
	amount = choice[1]
	if amount == 'all':
		amount = player_data[steamid]['cash']
	else:
		amount = int(amount)
	if player_data[steamid]['cash'] >= amount:
		bank(userid, steamid).transfer(choice[0], target_steamid, amount)
	else: 
		es.tell(userid, '#multi', '%sYou do not have #lightgreen%s #greento transfer!'%(tell_format, amount))

def asort(player_data): # Google's your friend
	rev_items = [(v, k) for k, v in player_data.items()]
	rev_items.sort(reverse=True)
	return [k for (v, k) in rev_items]

def top_select(userid, choice, popupid):
	es.tell(userid, '#multi', '%sSteamID - %s Cash - %s, Last Known Name - %s'%(tell_format, choice, player_data[choice]['cash'], player_data[choice]['name']))

def save_data():
	player_db = open(es.getAddonPath('bbank') + '/player_info.db', 'w')
	cPickle.dump(player_data, player_db)
	player_db.close()

def admin():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	if steamid in admins:
		if player_data.has_key(steamid):
			popuplib.send('Admin Menu', userid)
		else:
			es.tell(userid, '#multi', '%sPlease create an account first by typing #lightgreen!bank'%tell_format)


def admin_select(userid, choice, popupid):
	if choice == 'Give/Take Cash':
		admintake = popuplib.easymenu('Give/Take Cash', '_popup_choice', admingive_select)
		for userid2 in playerlib.getUseridList('#all'):
			admintake.addoption(userid2, playerlib.getPlayer(userid2).attributes['name'])
		popuplib.send('Give/Take Cash', userid)
	elif choice == 'Reset':
		popuplib.send('Are You Sure?', userid)
	elif choice == 'Change Player Accounts':
		accounttype = popuplib.easymenu('Change Account Types', '_popup_choice', account_type_select)
		for userid2 in playerlib.getUseridList('#all'):
			accounttype.addoption(userid2, playerlib.getPlayer(userid2).attributes['name'])
		popuplib.send('Change Account Types', userid)
		

def admingive_select(userid, choice, popupid):
	global player_data
	es.escinputbox(30, userid, '|-BBank Give/Take Cash-|', 'Please Input a value to Give/Take', 'cash')
	player_data[playerlib.getPlayer(userid).get('steamid')]['target'] = choice
	es.tell(userid, '#multi', '%sPress escape on your keyboard to input a value'%tell_format)

def givecash():
	userid = es.getcmduserid()
	amount = int(es.getargv(1))
	global player_data
	if playerlib.getPlayer(userid).get('steamid') in admins:
		if player_data[playerlib.getPlayer(userid).get('steamid')].has_key('target'):
			if player_data[playerlib.getPlayer(player_data[playerlib.getPlayer(userid).get('steamid')]['target']).get('steamid')]['cash'] + amount >= 0:
				player_data[playerlib.getPlayer(player_data[playerlib.getPlayer(userid).get('steamid')]['target']).get('steamid')]['cash'] += amount
				if amount > 0:
					es.tell(player_data[playerlib.getPlayer(userid).get('steamid')]['target'], '#multi', '%sAn admin has Given #lightgreen%s #greencash too you'%(tell_format, amount))
				else:
					es.tell(player_data[playerlib.getPlayer(userid).get('steamid')]['target'], '#multi', '%sAn admin has Taken #lightgreen%s #greencash from you'%(tell_format, -amount))
			else:
				es.tell(userid, '#multi', '%sSorry, that person does not have enough cash for you to take #lightgreen%s'%(tell_format, amount))
		else:
			es.tell(userid, '#multi', '%sPlease select a target!'%tell_format)
	else:
		es.tell(userid, '#multi', '%sSorry, you are not authorized to run this command!'%tell_format)

def pinfo_select(userid, choice, popupid):
	steamid = playerlib.getPlayer(choice).get('steamid')
	es.tell(userid, '#multi', '%sSteamID - #lightgreen%s Cash - %s, #greenLast Known Name - %s'%(tell_format, steamid, int(player_data[steamid]['cash']), player_data[steamid]['name']))

def confirm_reset(userid, choice, popupid):
	global player_data
	if choice == 'Yes':
		player_data.clear()

def transfer():
	userid = es.getcmduserid()
	target = es.getuserid(es.getargv(1))
	amount = es.getargv(2)
	if amount == 'all':
		amount = int(player_data[playerlib.getPlayer(userid).get('steamid')]['cash'])
	else:
		try:
			amount = int(amount)
		except ValueError:
			es.tell(userid, '#multi', '%s#lightgreen%s#green is an invalid amount!'%(tell_format, es.getargv(2)))
	if target:
		bank(userid, playerlib.getPlayer(userid).get('steamid')).transfer(target, playerlib.getPlayer(target).get('steamid'), amount)
	else:
		es.tell(userid, '#multi', '%sInvalid player'%tell_format)

def settings_select(userid, choice, popupid):
	if choice == 'Auto Balance':
		es.escinputbox(30, userid, '|-BBank Auto Balance-|', 'Please Input a value to auto have', 'abalance')
		es.tell(userid, '#multi', '%sPress escape on your keyboard to input a value to auto withdraw/deposit 0 == disabled'%tell_format)
	elif choice == 'Reset Account':
		popuplib.send('Reset Account?', userid)
		
def confirm_reset_2(userid, choice, popupid):
	if choice == 'Yes':
		global player_data
		player_data[playerlib.getPlayer(userid).get('steamid')]['cash'] = 0

def abalance():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	amount = int(es.getargv(1))
	if amount >= 0 and amount <= 16000:
		global player_data
		player_data[steamid]['abalance'] = amount
		es.tell(userid, '#multi', '%sYou will now automatically have #lightgreen%s #greencash on spawn!'%(tell_format, amount))
	else:
		es.tell(userid, '#multi', '%sPlease input a value below 16000 and above -1! 0 == disabled'%tell_format)

def player_spawn(ev):
	if player_data.has_key(ev['es_steamid']):
		bank(ev['userid'], ev['es_steamid']).check_keys()
		gamethread.delayed(0.1, bank(ev['userid'], ev['es_steamid']).abalance, args=())
		global player_data
		es.tell(ev['userid'], '#multi', '%sYou have gained a total of #lightgreen%s#green dollars from last round!'%(tell_format, int(player_data[ev['es_steamid']]['intrest'])))
		player_data[ev['es_steamid']]['intrest'] = 0
	else:
		bank(ev['userid'], ev['es_steamid']).create()

def account_type_select(userid, choice, popupid):
	accounttypemenu2 = popuplib.easymenu('Chose New Account', '_popup_choice', account_type_select2)
	for a in account_types:
		accounttypemenu2.addoption((choice, a), a)
	popuplib.send('Chose New Account', userid)

def account_type_select2(userid, choice, popupid):
	steamid = playerlib.getPlayer(userid).get('steamid')
	target_steamid = playerlib.getPlayer(choice[0]).get('steamid')
	type = choice[1]
	if player_data.has_key(target_steamid):
		global player_data
		player_data[target_steamid]['type'] = type
		es.tell(userid, '#multi', '%sYou have changed #lightgreen%s\'s #greenaccount type to #lightgreen%s'%(tell_format, playerlib.getPlayer(choice[0]).attributes['name'], type))
		es.tell(choice[0], '#multi', '%sAn admin has changed your account type to #lightgreen%s'%(tell_format, type))
	else: 
		es.tell(userid, '#multi', '%sPerson has not made an account yet'%(tell_format))

def est_map_end(ev):
	if bbank_auto_deposit_on_map_end:
		try:
			for userid in es.getUseridList():
				bank(userid, playerlib.getPlayer(userid).get('steamid')).deposit(playerlib.getPlayer(userid).get('cash'))
		except: pass